/*------------------------------------------------------------------------------
   EPA - Region II, ESD
  ------------------------------------------------------------------------------
   Program: jenkslib.h
   Purpose: head for functions in jenkslib.c
  ------------------------------------------------------------------------------
   Usage:   
  ------------------------------------------------------------------------------
   Calls:   
   Calling: jenks.c wieghtedjenks.c
  ------------------------------------------------------------------------------
   Notes:   
  ------------------------------------------------------------------------------
   History:
     Author/Site:    Date:       Event:
   Alan Brenner    12 Jan 94   Original coding
                   16 Aug 95   rewrite jenkshort routines
     alan_brenner@unixmail.edi.epa.gov
  ------------------------------------------------------------------------------
   Disclaimer:
     Although this program has been used by the U. S. Environmental Protection
   Agency, no warranty, expressed or implied, is made by the EPA as to the
   accurarcy and functioning of the program and related program material nor
   shall the fact of distribution constitute any such warranty, and no
   responsibility is assumed by the EPA in connection herewith.
==============================================================================*/

#ifndef _JENKSLIB_H_
# include <math.h>
# include "infolib.h"
# include "infodefs.h"

#define BUGOUT (void) fprintf

/* use in jenkshort to record testable points */
typedef struct jtest {
	  long pnt;
	  double gap;
     } jteststruct;

double ssd();
double sdc();
double bestgvf();
double step();
void makelut();
void openlut();
void writelut();

# define _JENKSLIB_H_
#endif
