/*statistical functions some simple and some (many) derived from: */
/* William H. Press, Brian P. Flannery, Saul A. Teukolsky and William T. Vettering */
/* NUMERICAL RECIPIES in C: The Art of Scientific Computing */
/* Cambridge University Press, 1988 */
/*written by Alan Brenner 16 November 1992 and reworked 12 Jan 94*/

#include "stats.h"

double adev(n, ave, data)				    /* calculate average deviation */
  long n;
  double ave,*data;
{
     long j;
     double adev=0;

     if (n<1)
     {
	  (void) fprintf(stderr,"Average deviation requires at least one data value.\n");
	  (void) fprintf(stderr,"Returning 0 as NODATA.\n");
	  return(0.0);
     }

     for (j=0; j<n; j++)
	  adev+=fabs(data[j])-ave;

     return(adev/n);
}
