/*statistical functions some simple and some (many) derived from: */
/* William H. Press, Brian P. Flannery, Saul A. Teukolsky and William T. Vettering */
/* NUMERICAL RECIPIES in C: The Art of Scientific Computing */
/* Cambridge University Press, 1988 */
/*written by Alan Brenner 16 November 1992 and reworked 12 Jan 94*/

#include "stats.h"

double betacf(a, b, x)					    /*incomplete beta function for Student's t*/
  double a,b,x;
{							    /*Press et al, p180*/
     double qap,qam,qab,em,tem,d,bz,bm=1.0,bp,bpp,az=1.0,am=1.0,ap,app,aold;
     int m;
     
     qab=a+b;
     qap=a+1.0;
     qam=a-1.0;
     bz=1.0-qab*x/qap;

     for (m=1; m<=100; m++)
     {
	  em=(float) m;
	  tem=em+em;
	  d=em*(b-em)*x/((qam+tem)*(a+tem));
	  ap=az+d*am;
	  bp=bz+d*bm;
	  d=-(a+em)*(qab+em)*x/((qap+tem)*(a+tem));
	  app=ap+d*az;
	  bpp=bp+d*bz;
	  aold=az;
	  am=ap/bpp;
	  bm=bp/bpp;
	  az=app/bpp;
	  bz=1.0;
	  if (fabs(az-aold)<(3.0e-7*fabs(az)))
	       return(az);
     }
     (void) fprintf(stderr,"Data out of range in betacf.\nReturning 0 as NODATA.\n");
     return(0.0);
}
