/*statistical functions some simple and some (many) derived from: */
/* William H. Press, Brian P. Flannery, Saul A. Teukolsky and William T. Vettering */
/* NUMERICAL RECIPIES in C: The Art of Scientific Computing */
/* Cambridge University Press, 1988 */
/*written by Alan Brenner 16 November 1992 and reworked 12 Jan 94*/

#include "stats.h"

double betai(a, b, x)					    /*incomplete beta function for Students' t*/
  double a,b,x;
{							    /*Press et al, p179*/
     double bt;

     if (x<0.0 || x>1.0)
     {
	  (void) fprintf(stderr,"Data out of range in betai.\nReturning 0 as NODATA.\n");
	  return(0.0);
     }

     if (x==0.0 || x==1.0)
	  bt=0.0;
     else
	  bt=exp(gammln(a+b)-gammln(a)-gammln(b)+a*log(x)+b*log(1.0-x));

     if (x<(a+1.0)/(a+b+2.0))
	  return(bt*betacf(a,b,x)/a);
     else
	  return(1.0-bt*betacf(b,a,1.0-x)/b);
}
