/*statistical functions some simple and some (many) derived from: */
/* William H. Press, Brian P. Flannery, Saul A. Teukolsky and William T. Vettering */
/* NUMERICAL RECIPIES in C: The Art of Scientific Computing */
/* Cambridge University Press, 1988 */
/*written by Alan Brenner 16 November 1992 and reworked 12 Jan 94*/

#include "stats.h"

double chisquare1(n,data, expect, constrn, df, prob)
  long n,constrn;
  double *data,*expect,*df,*prob;
{
     int j;
     double t,chisq=0.0;

     *df=(double)n-1.0-constrn;
     for (j=0; j<n; j++)
     {
	  if (expect[j] <= 0.0)
	  {
	       (void) fprintf(stderr,"Expected number must be greater than zero.\n");
	       (void) fprintf(stderr,"Returning 0 as NODATA.\n");
	       *prob=0.0;
	       return(*prob);
	  }
	  t=data[j]-expect[j];
	  chisq+=t*t/expect[j];
     }
     *prob=gammq(*df/2.0,chisq/2.0);
     return(chisq);
}
