/*statistical functions some simple and some (many) derived from: */
/* William H. Press, Brian P. Flannery, Saul A. Teukolsky and William T. Vettering */
/* NUMERICAL RECIPIES in C: The Art of Scientific Computing */
/* Cambridge University Press, 1988 */
/*written by Alan Brenner 16 November 1992 and reworked 12 Jan 94*/

#include "stats.h"

double chisquare2(n, data1, data2, constrn, df, prob)
  long n,constrn;
  double *data1,*data2,*df,*prob;
{
     int j;
     double t,chisq=0.0;

     *df=n-1-constrn;
     for (j=0; j<n; j++)
     {
	  if (data1[j]==0.0 && data2[j]==0.0)
	       *df-=1.0;
	  else
	  {
	       t=data1[j]-data2[j];
	       chisq+=t*t/(data1[j]+data2[j]);
	  }
     }
     *prob=gammq(*df/2.0,chisq/2.0);
     return(chisq);
}
