/*statistical functions some simple and some (many) derived from: */
/* William H. Press, Brian P. Flannery, Saul A. Teukolsky and William T. Vettering */
/* NUMERICAL RECIPIES in C: The Art of Scientific Computing */
/* Cambridge University Press, 1988 */
/*written by Alan Brenner 16 November 1992 and reworked 12 Jan 94*/

#include <string.h>
#include "stats.h"

char *cmode(n, data)
  long n;
  char *data[];
{
     long i,j,*cntr,*uneke,unique=1,swtch;

     if ((cntr=calloc(n,sizeof(long)))==NULL)
	  error(-1,"Cannot allocate memory in cmode.");
     if ((uneke=calloc(n,sizeof(long)))==NULL)
	  error(-2,"Cannot allocate memory in cmode.");
     cntr[0]=1;						    /* first value is always unique */
     uneke[0]=0;

     for (i=1; i<n; i++)				    /* for every other possible point */
     {
	  swtch=0;
	  for (j=0; j<unique; j++)			    /* check the current list unique of unique points */
	  {
	       if (strcmp(data[i],data[uneke[j]])==0)	    /* if point is equal to member of unique set */
	       {
		    cntr[j]++;				    /* increment unique counter */
		    swtch=1;				    /* set swtich for not a new unique value */
	       }
	  }
	  if (swtch==0)					    /* unique new value */
	  {
	       unique++;				    /* increment total number of unique values */
	       uneke[unique]=i;				    /* add pointer to unique list */
	       cntr[unique]=1;				    /* set unique count to one */
	  }
     }

     if (unique==1)					    /* all values are the same */
	  return(data[uneke[0]]);

     j=0;						    /* set the possible output to the first value */
     swtch = cntr[0];
     
     for (i=1; i<unique; i++)				    /* for each other uneke value */
     {
	  if (swtch<cntr[i])				    /* if the total number of occurances > current */
	  {
	       swtch=cntr[i];				    /* keep the new occurance */
	       j=i;					    /* keep the new data value */
	  }
     }

     i=uneke[j];
     free(cntr);
     free(uneke);
     return(data[i]);					    /* output the (single) modal data value */
}
