/*statistical functions some simple and some (many) derived from: */
/* William H. Press, Brian P. Flannery, Saul A. Teukolsky and William T. Vettering */
/* NUMERICAL RECIPIES in C: The Art of Scientific Computing */
/* Cambridge University Press, 1988 */
/*written by Alan Brenner 16 November 1992 and reworked 12 Jan 94*/

#include "stats.h"

double eqvttest(n1, data1, n2, data2, prob)
  long n1,n2;
  double *data1,*data2,*prob;
{							    /* Press et al, p483 */
     double av1,av2,var1,var2,var,df,t;

     av1=mean(n1,data1);
     av2=mean(n2,data2);
     var1=svar(n1,av1,data1);
     var2=svar(n2,av2,data2);

     df=n1+n2-2;
     var=((n1-1)*var1+(n2-1)*var2)/df;
     t=(av1-av2)/sqrt(var*(1.0/n1+1.0/n2));
     *prob=betai(df/2.0,0.5,df/(df+t*t));
     return(t);
}
