/*statistical functions some simple and some (many) derived from: */
/* William H. Press, Brian P. Flannery, Saul A. Teukolsky and William T. Vettering */
/* NUMERICAL RECIPIES in C: The Art of Scientific Computing */
/* Cambridge University Press, 1988 */
/*written by Alan Brenner 16 November 1992 and reworked 12 Jan 94*/

#include "stats.h"

double ftest(n1, data1, n2, data2, prob)
  long n1, n2;
  double *data1,*data2,*prob;
{
     double av1,av2,var1,var2,df1,df2,f;

     av1=mean(n1,data1);
     av2=mean(n2,data2);
     var1=svar(n1,av1,data1);
     var2=svar(n2,av2,data2);

     if (var1>var2)
     {
	  f=var1/var2;
	  df1=n1-1;
	  df2=n2-1;
     }
     else
     {
	  f=var2/var1;
	  df1=n2-1;
	  df2=n1-1;
     }

     *prob=2.0*betai(df2/2.0,df1/2.0,df2/(df2+df1*f));
     if (*prob>1.0) *prob=2.0-*prob;
     return(f);
}
