/*statistical functions some simple and some (many) derived from: */
/* William H. Press, Brian P. Flannery, Saul A. Teukolsky and William T. Vettering */
/* NUMERICAL RECIPIES in C: The Art of Scientific Computing */
/* Cambridge University Press, 1988 */
/*written by Alan Brenner 16 November 1992 and reworked 12 Jan 94*/

#include "stats.h"

double gammln(xx)					    /*natural log gamma function for Student's t*/
  double xx;
{							    /*Press et al, p168*/
     double x,tmp,ser;
     static double cof[6]={76.18009173,-86.50532033,24.01409822,-1.231739516,0.120858003e-2,-0.536382e-5};
     int j;
     
     x=xx-1.0;
     tmp=x+5.5;
     tmp-=(x+0.5)*log(tmp);
     ser=1.0;
     for (j=0; j<=5; j++)
     {
	  x+=1.0;
	  ser+=cof[j]/x;
     }
     return(-tmp+log(2.50662827465*ser));
}
