/*statistical functions some simple and some (many) derived from: */
/* William H. Press, Brian P. Flannery, Saul A. Teukolsky and William T. Vettering */
/* NUMERICAL RECIPIES in C: The Art of Scientific Computing */
/* Cambridge University Press, 1988 */
/*written by Alan Brenner 16 November 1992 and reworked 12 Jan 94*/

#include "stats.h"

double gammp(a,x)
  double a,x;
{
     double gln=0.0;

     if (x<0.0 || a<=0.0)
     {
	  (void) fprintf(stderr,"X must be >= 0 and A must be > 0.\nReturning 0 as NODATA.\n");
	  return(0.0);
     }
     if (x<(a+1.0))
	  return(gser(a,x,&gln));
     else
	  return(1.0-gcf(a,x,&gln));
}
