/*statistical functions some simple and some (many) derived from: */
/* William H. Press, Brian P. Flannery, Saul A. Teukolsky and William T. Vettering */
/* NUMERICAL RECIPIES in C: The Art of Scientific Computing */
/* Cambridge University Press, 1988 */
/*written by Alan Brenner 16 November 1992 and reworked 12 Jan 94*/

#include "stats.h"

#define ITMAX 1000
#define EPS 3.0e-7

double gcf(a, x, gln)
  double a,x,*gln;
{
     long j;
     double gold=0.0,g,fac=1.0,b0=0.0,b1=1.0,an,ana,anf,a0=1.0,a1;

     *gln=gammln(a);
     a1=x;
     for (j=0; j<ITMAX; j++)
     {
	  an=(double) j;
	  ana=an-a;
	  a0=(a1+a0*ana)*fac;
	  b0=(b1+b0*ana)*fac;
	  anf=an*fac;
	  a1=x*a0+anf*a1;
	  b1=x*b0+anf*b1;
	  if (a1)
	  {
	       fac=1.0/a1;
	       g=b1*fac;
	       if (fabs((g-gold)/g) < EPS)
		    return(exp(-x+a*log(x)-*gln)*g);
	       gold=g;
	  }
     }
     (void) fprintf(stderr,"A to large for ITMAX in routine gcf.\nReturning 0 as NODATA.\n");
     return(0);
}
