/*statistical functions some simple and some (many) derived from: */
/* William H. Press, Brian P. Flannery, Saul A. Teukolsky and William T. Vettering */
/* NUMERICAL RECIPIES in C: The Art of Scientific Computing */
/* Cambridge University Press, 1988 */
/*written by Alan Brenner 16 November 1992 and reworked 12 Jan 94*/

#include "stats.h"

#define ITMAX 1000
#define EPS 3.0e-7

double gser(a,x,gln)
  double a,x,*gln;
{
     long j;
     double sum,del,ap;

     *gln=gammln(a);
     if (x<=0.0)
     {
	  if (x<0.0)
	       (void) fprintf(stderr,"X must be greater than zero in gser.\nReturning 0 as NODATA.\n");
	  return(0.0);
     }

     ap=a;
     del=sum=1.0/a;
     for (j=1; j<ITMAX; j++)
     {
	  ap+=1.0;
	  del*=x/ap;
	  sum+=del;
	  if (fabs(del)<fabs(sum)*EPS)
	       return(sum*exp(-x+a*log(x)-*gln));
     }
     (void) fprintf(stderr,"A too large for ITMAX in gser.\nReturning 0 as NODATA.\n");
     return(0.0);
}
