/*statistical functions some simple and some (many) derived from: */
/* William H. Press, Brian P. Flannery, Saul A. Teukolsky and William T. Vettering */
/* NUMERICAL RECIPIES in C: The Art of Scientific Computing */
/* Cambridge University Press, 1988 */
/*written by Alan Brenner 16 November 1992 and reworked 12 Jan 94*/

#include "stats.h"

double kendl(n, data1, data2, z, prob)
  long n;
  double *data1, *data2, *z, *prob;
{
     long n1=0,n2=0,j,k,is=0;
     double svar,aa,a1,a2,tau;

     for (j=0; j<n-1; j++)
     {
	  for (k=j+1; k<n; k++)
	  {
	       a1=data1[j]-data1[k];
	       a2=data2[j]-data2[k];
	       aa=a1*a2;
	       if (aa)
	       {
		    n1++;
		    n2++;
		    aa>0.0 ? ++is : --is;
	       }
	       else
	       {
		    if (a1) ++n1;
		    if (a2) ++n2;
	       }
	  }
     }
     tau=((double) is)/(sqrt((double) n1)*sqrt((double) n2));
     svar=(4.0*n+10.0)/(9.0*n*(n-1.0));
     *z=tau/sqrt(svar);
     *prob=erfcc(fabs(*z)/sqrt(2.0));
     return(tau);
}
