/*statistical functions some simple and some (many) derived from: */
/* William H. Press, Brian P. Flannery, Saul A. Teukolsky and William T. Vettering */
/* NUMERICAL RECIPIES in C: The Art of Scientific Computing */
/* Cambridge University Press, 1988 */
/*written by Alan Brenner 16 November 1992 and reworked 12 Jan 94*/

#include "stats.h"

double kendlt(tab, i, j, z, prob)
  long i,j;
  double *tab[],*z,*prob;
{
     long nn,mm,m1,m2,l,li,lj,k,ki,kj;
     double svar,s=0.0,points,pairs,en1=0.0,en2=0.0,tau;

     nn=i*j;
     points=tab[i][j];
     for (k=0; k<=nn-2; k++)
     {
	  ki=k/j;
	  kj=k-j*ki;
	  points+=tab[ki+1][kj+1];
	  for (l=k+1; l<=nn-1; l++)
	  {
	       li=l/j;
	       lj=l-j*li;
	       mm=(m1=li-ki)*(m2=lj-kj);
	       pairs=tab[ki+1][kj+1]*tab[li+1][lj+1];
	       if (mm)
	       {
		    en1+=pairs;
		    en2+=pairs;
		    s+=(mm>0 ? pairs : -pairs);
	       }
	       else
	       {
		    if (m1) en1+=pairs;
		    if (m2) en2+=pairs;
	       }
	  }
     }
     tau=s/sqrt(en1*en2);
     svar=(4.0*points+10.0)/(9.0*points*(points-1.0));
     *z=tau/sqrt(svar);
     *prob=erfcc(fabs(*z)/sqrt(2.0));
     return(tau);
}
