/*statistical functions some simple and some (many) derived from: */
/* William H. Press, Brian P. Flannery, Saul A. Teukolsky and William T. Vettering */
/* NUMERICAL RECIPIES in C: The Art of Scientific Computing */
/* Cambridge University Press, 1988 */
/*written by Alan Brenner 16 November 1992 and reworked 12 Jan 94*/

#include "stats.h"

double ks1(n, data, func, prob)
  long n;
  double *data,(*func)(),*prob;
{
     long j;
     double fo=0.0,fn,ff,en,dt,d=0.0;

     en=(double) n;
     for (j=0; j<n; j++)
     {
	  fn=j/en;
	  ff=(*func)(data[j]);
	  dt=fabs(fo-ff)>fabs(fn-ff) ? fabs(fo-ff) : fabs(fn-ff);
	  if (dt>d) d=dt;
	  fo=fn;
     }
     *prob=probks(sqrt(en)*d);
     return(d);
}
