/*statistical functions some simple and some (many) derived from: */
/* William H. Press, Brian P. Flannery, Saul A. Teukolsky and William T. Vettering */
/* NUMERICAL RECIPIES in C: The Art of Scientific Computing */
/* Cambridge University Press, 1988 */
/*written by Alan Brenner 16 November 1992 and reworked 12 Jan 94*/

#include "stats.h"

double ks2(n1, data1, n2, data2, prob)
  long n1,n2;
  double *data1,*data2,*prob;
{
     long i=0,j=0;
     double en1,en2,fn1=0.0,fn2=0.0,dt,d=0.0;

     en1=(double) n1;
     en2=(double) n2;

     while (i<n1 && j<n2)
     {
	  if (data1[i]<=data2[j])
	       fn1=(i++)/en1;
	  if (data2[j]<=data1[i])
	       fn2=(j++)/en2;
	  if ((dt=fabs(fn2-fn1))>d) d=dt;
     }
     *prob=probks(sqrt(en1*en2/(en1+en2))*d);
     return(d);
}
