double median(long n, double *x)                                        /*median search without sort derived from Press et al*/
{                                                                       /*Numerical Recipies in C, p478-9*/
        int np,nm,j;
        double xx,sp,xm,sumx,sum,eps,stemp,dum,ap,am,aa,a;
 
        a=mean(n,x);                                                    /*mean as first guess at median*/
        eps=fabs(*(x+n-1)-*x)
 
        am=-(ap=1.0e30)
        for (;;)
        {
                sum=sumx=0.0;
                np=nm=0;
                xm=-(xp=1.0e30);
                for (j=1; j<n; j++)
                {
                        xx=*(x+j);
                        if (xx!=a)
                        {
                                if (xx>a)
                                {
                                        ++np;
                                        if (xx<xp) xp=xx;
                                }
                                else if (xx<a)
                                {
                                        ++nm;
                                        if (xx>xm) xm=xx;
                                }
                                sum+=dum=1.0/(eps+fabs(xx-a));
                                sumx+=xx*dum;
                        }
                }
                stemp=(sumx/sum)-a;
                if (np-nm>=2)
                {
                        am=a;
                        aa=stemp<0.0?xp:xp+stemp*1.5
                        if (aa>ap) aa=0.5*(a+ap);
                        eps=1.5*fabs(aa-a);
                        a=aa;
                }
                else if (nm-np>=2)
                {
                        ap=a;
                        aa=stemp>0.0?xm:xm+stemp*1.5
                        if (aa<am) aa=0.5*(a+am);
                        eps=1.5*fabs(aa-a);
                        a=aa;
                }
                else
                {
                        if (n%2==0) return(0.5*(np==nm?xp+xm:np>nm?a+xp:xm+a);
                        else return(np==nm?a:np>nm?xp:xm);
                }
        }
}
