/*statistical functions some simple and some (many) derived from: */
/* William H. Press, Brian P. Flannery, Saul A. Teukolsky and William T. Vettering */
/* NUMERICAL RECIPIES in C: The Art of Scientific Computing */
/* Cambridge University Press, 1988 */
/*written by Alan Brenner 16 November 1992 and reworked 12 Jan 94 and 12 Jan 95*/

#include "stats.h"

void medianc(n, data, cases, ccases, dcases, cdata, ndata, csize, output)
  char **ccases,**cdata;				    /* find median for cased data */
  short csize;
  long n,cases;
  double *data, *dcases, *ndata, **output;
{
     long i,j,count;
     double *casedata;

     casedata=calloc(n,sizeof(double));			    /* space for local copy of data */
     for (i=0; i<cases; i++)				    /* for each case */
     {
	  for (count=j=0; j<n; j++)			    /* find each case */
	  {
	       if (csize>0)				    /* character cases */
	       {
		    if (strcmp(*ccases+i*csize,*cdata+j*csize)==0)
		    {					    /* this value is part of this case? */
			 casedata[count]=data[j];	    /* the value is in the group */
			 count++;			    /* increment count of items in group */
		    }
	       }
	       else					    /* numberic cases */
	       {
		    if (dcases[i]==ndata[j])		    /* this value is part of this case? */
		    {
			 casedata[count]=data[j];	    /* the value is in the group */
			 count++;
		    }
	       }
	  }

	  if (count==1)					    /* only one item */
	       *(*output+i)=casedata[0];		    /* that item is the median */
	  else
	       *(*output+i)=median(count,casedata);	    /* go find the median for this case */
     }
}
