/*statistical functions some simple and some (many) derived from: */
/* William H. Press, Brian P. Flannery, Saul A. Teukolsky and William T. Vettering */
/* NUMERICAL RECIPIES in C: The Art of Scientific Computing */
/* Cambridge University Press, 1988 */
/*written by Alan Brenner 16 November 1992 and reworked 12 Jan 94 and 12 Jan 95*/

#include "stats.h"

void minc(n, data, cases, ccases, dcases, cdata, ndata, csize, output)
  char **ccases,**cdata;				    /* find minimum for cased data */
  short csize;
  long n,cases;
  double *data, *dcases, *ndata, **output;
{
     long i,j;

     for (i=0; i<cases; i++)				    /* for each case */
     {
	  for (j=0; j<n; j++)				    /* find the first value for each case */
	  {
	       if (csize>0)				    /* character cases */
	       {
		    if (strcmp(*ccases+i*csize,*cdata+j*csize)==0)
		    {					    /* this value is part of this case? */
			 *(*output+i)=data[j];		    /* the value is the initial low */
			 break;				    /* exit j loop */
		    }
	       }
	       else					    /* numberic cases */
	       {
		    if (dcases[i]==ndata[j])		    /* this value is part of this case? */
		    {
			 *(*output+i)=data[j];		    /* then the value is initial low */
			 break;				    /* exit */
		    }
	       }
	  }
     }

     for (i=0; i<cases; i++)				    /* for each case */
     {
	  for (j=1; j<n; j++)				    /* for every data value, skipping #0 which can't be less than itself */
	  {
	       if (csize>0)				    /* character cases */
	       {
		    if (strcmp(*ccases+i*csize,*cdata+j*csize)==0 && *(*output+i)>data[j])
			 *(*output+i)=data[j];		    /* this valus is the current case and less than the current low*/
	       }
	       else
	       {
		    if (dcases[i]==ndata[j] && *(*output+i)>data[j])
			 *(*output+i)=data[j];		    /* this value is part of this case? */
	       }
	  }
     }
}
