/*statistical functions some simple and some (many) derived from: */
/* William H. Press, Brian P. Flannery, Saul A. Teukolsky and William T. Vettering */
/* NUMERICAL RECIPIES in C: The Art of Scientific Computing */
/* Cambridge University Press, 1988 */
/*written by Alan Brenner 16 November 1992 and reworked 12 Jan 94*/

#include "stats.h"

double pairttest(n, data1, data2, prob)
  long n;
  double *data1,*data2,*prob;
{							    /* Press et al, p485 */
     long j;
     double av1,av2,var1,var2,sd,df,cov=0.0,t;

     av1=mean(n,data1);
     av2=mean(n,data2);
     var1=svar(n,av1,data1);
     var2=svar(n,av2,data2);

     for (j=0; j<n; j++)
	  cov+=(data1[j]-av1)*(data2[j]-av2);
     cov/=df=n-1;
     sd=sqrt((var1+var2-2.0*cov)/n);
     t=(av1-av2)/sd;
     *prob=betai(df/2.0,0.5,df/(df+t*t));
     return(t);
}
