/*statistical functions some simple and some (many) derived from: */
/* William H. Press, Brian P. Flannery, Saul A. Teukolsky and William T. Vettering */
/* NUMERICAL RECIPIES in C: The Art of Scientific Computing */
/* Cambridge University Press, 1988 */
/*written by Alan Brenner 16 November 1992 and reworked 12 Jan 94*/

#include "stats.h"

#define TINY 1.0e-20

double pearson(n, ax, ay, x, y, prob, z)		    /*calculate correlaction coefficient*/
  long n;
  double ax,ay,*x,*y,*prob,*z;
{
     long j;
     double r,syy=0,sxy=0,sxx=0,df,t;

     for  (j=0; j<n; j++)
     {
	  sxx+=(*(x+j)-ax)*(*(x+j)-ax);
	  syy+=(*(y+j)-ay)*(*(y+j)-ay);
	  sxy+=(*(x+j)-ax)*(*(y+j)-ay);
     }
     r=sxy/sqrt(sxx*syy);
     *z=0.5*log((1.0+r+TINY)/(1.0-r+TINY));
     df=(double) n-2;
     t=r*sqrt(df/((1.0-r+TINY)*(1.0+r+TINY)));
     *prob=betai(df/2.0,0.5,df/(df+t*t));
     return(r);						    /*return r*/
}
