/*statistical functions some simple and some (many) derived from: */
/* William H. Press, Brian P. Flannery, Saul A. Teukolsky and William T. Vettering */
/* NUMERICAL RECIPIES in C: The Art of Scientific Computing */
/* Cambridge University Press, 1988 */
/*written by Alan Brenner 16 November 1992 and reworked 12 Jan 94*/

#include "stats.h"

#define EPS1 0.001
#define EPS2 1.0e-8

double probks(alam)
  double alam;
{
     long j;
     double a2,fac=2.0,sum=0.0,term,termbf=0.0;

     a2=-2.0*alam*alam;
     for (j=1; j<=100; j++)
     {
	  term=fac*exp(a2*j*j);
	  sum+=term;
	  if (fabs(term)<=EPS1*termbf || fabs(term)<=EPS2*sum) return(sum);
	  fac=-fac;
	  termbf=fabs(term);
     }
     return(1.0);
}
