/*statistical functions some simple and some (many) derived from: */
/* William H. Press, Brian P. Flannery, Saul A. Teukolsky and William T. Vettering */
/* NUMERICAL RECIPIES in C: The Art of Scientific Computing */
/* Cambridge University Press, 1988 */
/*written by Alan Brenner 16 November 1992 and reworked 12 Jan 94*/

#include "stats.h"

double skew(n, ave, var, data)
  long n;
  double ave,var,*data;
{
     long j;
     double skew=0;

     if (n<2)
     {
	  (void) fprintf(stderr,"There must be more than one data value to calculate skewness.\n");
	  (void) fprintf(stderr,"Returning 0 as NODATA.\n");
	  return(0.0);
     }
     if (var<0)
     {
	  (void) fprintf(stderr,"Garbage input for variance--it is less than zero.\n");
	  (void) fprintf(stderr,"Returning 0 as NODATA.\n");
	  return(0.0);
     }
     if (var==0)
     {
	  (void) fprintf(stderr,"Skewness cannot be calculated when variance is zero.\n");
	  (void) fprintf(stderr,"Returning 0 as NODATA.\n");
	  return(0.0);
     }

     for (j=0; j<n; j++)
	  skew+=pow(data[j]-ave,3);

     return(skew/(n*var*sqrt(var)));
}
