/*statistical functions some simple and some (many) derived from: */
/* William H. Press, Brian P. Flannery, Saul A. Teukolsky and William T. Vettering */
/* NUMERICAL RECIPIES in C: The Art of Scientific Computing */
/* Cambridge University Press, 1988 */
/*written by Alan Brenner 16 November 1992 and reworked 12 Jan 94 and 13 Jan 95*/

#include "stats.h"

void skewc(n, data, cases, aves, vars, ccases, dcases, cdata, ndata, csize, output)
  char **ccases,**cdata;				    /* find skewness for cased data */
  short csize;
  long n,cases;
  double *aves, *vars, *data, *dcases, *ndata, **output;
{
     long i,j,count;
     double *casedata;

     casedata=calloc(cases,sizeof(double));		    /* space for each case's data */

     for (i=0; i<cases; i++)				    /* for each case */
     {
	  for (count=j=0; j<n; j++)			    /* find the values for each case */
	  {
	       if (csize>0)				    /* character cases */
	       {
		    if (strcmp(*ccases+i*csize,*cdata+j*csize)==0)
		    {					    /* this value is part of this case? */
			 casedata[count]=data[j];	    /* keep data value */
			 count++;			    /* increment total number of occurances */
		    }
	       }
	       else					    /* numberic cases */
	       {
		    if (dcases[i]==ndata[j])		    /* this value is part of this case? */
		    {
			 casedata[count]=data[j];	    /* keep data value */
			 count++;			    /* increment count */
		    }
	       }
	  }
	  if (count==1 || vars[i]<=0)			    /* if only one data item or no variance*/
	       *(*output+i)=0;				    /* the skewnessis is undefined */
	  else						    /* find & record the skewness */
	       *(*output+i)=skew(count,aves[i],vars[i],casedata);
     }
}
