/*statistical functions some simple and some (many) derived from: */
/* William H. Press, Brian P. Flannery, Saul A. Teukolsky and William T. Vettering */
/* NUMERICAL RECIPIES in C: The Art of Scientific Computing */
/* Cambridge University Press, 1988 */
/*written by Alan Brenner 16 November 1992 and reworked 12 Jan 94 and 12 Jan 95*/

#include "stats.h"

void sumc(n, data, cases, ccases, dcases, cdata, ndata, csize, output)
  char **ccases,**cdata;				    /* find sums for cased data */
  short csize;
  long n,cases;
  double *data, *dcases, *ndata, **output;
{
     long i,j;

     for (i=0; i<cases; i++)				    /* initialize all data to zero */
	  *(*output+i)=0.0;

     for (i=0; i<cases; i++)				    /* for each case */
     {
	  for (j=0; j<n; j++)				    /* find the first value for each case */
	  {
	       if (csize>0)				    /* character cases */
	       {
		    if (strcmp(*ccases+i*csize,*cdata+j*csize)==0)
		    					    /* this value is part of this case? */
			 *(*output+i)+=data[j];		    /* keep running total */
	       }
	       else					    /* numberic cases */
	       {
		    if (dcases[i]==ndata[j])		    /* this value is part of this case? */
			 *(*output+i)+=data[j];		    /* keep running total */
	       }
	  }
     }
}
