/* stats.h */
/* header for some of the statistics routines I find useful */
/* by Alan Brenner */
/* 12 January 1994 */


#ifndef _STATSLIB_H_
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "utils.h"

/* set this to debug level */
extern char debug;

double adev();

double betacf();
double betai();

double chisquare1();
double chisquare2();

char *cmode();

double cta();
double ecta();

double erf();
double erfc();
double erfcc();

double eqvttest();

double ftest();

double gammln();
double gammp();
double gammq();

double gcf();
double gser();

double kendl();
double kendlt();

double ks1();
double ks2();

double kurt();
void kurtc();

double linearreg1();

double max();
double maxr();
void maxc();
void maxrc();

double mean();
void meanc();

double median();
void medianc();

double min();
double minr();
void minc();
void minrc();

double mode();
void modec();

double mmm();

double pairttest();

double pearson();

double probks();

double psd();
void psdc();

double pvar();
void pvarc();

double robustest();

double skew();
void skewc();

double ssd();
void ssdc();

double spear();
double sum();

long stat_index();

void sumc();

double svar();
void svarc();

double uevttest();

#define _STATSLIB_H_
#endif
